/*
http://downloads.sourceforge.net/keepass/KeePass-1.35.zip
http://downloads.sourceforge.net/keepass/KeePass-1.27-Chinese_Simplified.zip
http://downloads.sourceforge.net/keepass/KeePass-1.27-Chinese_Traditional.zip
http://downloads.sourceforge.net/keepass/KeePass-1.26-Danish.zip
http://downloads.sourceforge.net/keepass/KeePass-1.27-Dutch.zip
http://downloads.sourceforge.net/keepass/KeePass-1.35-French.zip
http://downloads.sourceforge.net/keepass/KeePass-1.27-German.zip
http://downloads.sourceforge.net/keepass/KeePass-1.27-Hungarian.zip
http://downloads.sourceforge.net/keepass/KeePass-1.27-Italian.zip
http://downloads.sourceforge.net/keepass/KeePass-1.27-Japanese.zip
http://downloads.sourceforge.net/keepass/KeePass-1.27-Lithuanian.zip
http://downloads.sourceforge.net/keepass/KeePass-1.27-Polish.zip
http://downloads.sourceforge.net/keepass/KeePass-1.27-Portuguese_PT.zip
http://downloads.sourceforge.net/keepass/KeePass-1.26-Russian.zip
http://downloads.sourceforge.net/keepass/KeePass-1.27-Slovak.zip
http://downloads.sourceforge.net/keepass/KeePass-1.27-Spanish.zip
http://downloads.sourceforge.net/keepass/KeePass-1.27-Swedish.zip
http://downloads.sourceforge.net/keepass/KeePass-1.26-Turkish.zip
http://downloads.sourceforge.net/keepass/KeePass-1.27-Ukrainian.zip

http://downloads.sourceforge.net/keepass/KeePass-2.26.zip
http://downloads.sourceforge.net/keepass/KeePass-2.26-Chinese_Simplified.zip
http://downloads.sourceforge.net/keepass/KeePass-2.26-Chinese_Traditional.zip
http://downloads.sourceforge.net/keepass/KeePass-2.25-Danish.zip
http://downloads.sourceforge.net/keepass/KeePass-2.26-Dutch.zip
http://downloads.sourceforge.net/keepass/KeePass-2.26-French.zip
http://downloads.sourceforge.net/keepass/KeePass-2.26-German.zip
http://downloads.sourceforge.net/keepass/KeePass-2.26-Hungarian.zip
http://downloads.sourceforge.net/keepass/KeePass-2.26-Italian.zip
http://downloads.sourceforge.net/keepass/KeePass-2.26-Japanese.zip
http://downloads.sourceforge.net/keepass/KeePass-2.26-Lithuanian.zip
http://downloads.sourceforge.net/keepass/KeePass-2.26-Polish.zip
http://downloads.sourceforge.net/keepass/KeePass-2.26-Portuguese_PT.zip
http://downloads.sourceforge.net/keepass/KeePass-2.25-Russian.zip
http://downloads.sourceforge.net/keepass/KeePass-2.26-Slovak.zip
http://downloads.sourceforge.net/keepass/KeePass-2.26-Spanish.zip
http://downloads.sourceforge.net/keepass/KeePass-2.26-Swedish.zip
http://downloads.sourceforge.net/keepass/KeePass-2.25-Turkish.zip
http://downloads.sourceforge.net/keepass/KeePass-2.26-Ukrainian.zip
*/
!define RELEASURL	"http://downloads.sourceforge.net/keepass/KeePass"
!define APPSIZE	"1024" # kB
!define DLVER	"MultiVersion"
!define APPVER 	"0.0.0.0"
!define APPNAME "KeePass Password Safe"
!define APP 	"KeePass"
!define DLNAME	"KeePass"
!define APPLANG	"Multilingual_Online"
!define FOLDER	"KeePassPortable"
!define MULTILANG ; Delete if not MultiLang
; !define FINISHRUN ; Delete if not Finish pages
!define SOURCES ; Delete if no Sources
; !define DESCRIPTION	"Password manager" ; Delete if no AppInfo
!define INPUTBOX ; Delete if no InputBox

SetCompressor /SOLID lzma
SetCompressorDictSize 32

!include "..\_Include\Installer.nsh"

!insertmacro MUI_LANGUAGE "English"
!insertmacro MUI_LANGUAGE "SimpChinese"
!insertmacro MUI_LANGUAGE "TradChinese"
!insertmacro MUI_LANGUAGE "Danish"
!insertmacro MUI_LANGUAGE "Dutch"
!insertmacro MUI_LANGUAGE "French"
!insertmacro MUI_LANGUAGE "German"
!insertmacro MUI_LANGUAGE "Hungarian"
!insertmacro MUI_LANGUAGE "Italian"
!insertmacro MUI_LANGUAGE "Japanese"
!insertmacro MUI_LANGUAGE "Lithuanian"
!insertmacro MUI_LANGUAGE "Polish"
!insertmacro MUI_LANGUAGE "Portuguese"
!insertmacro MUI_LANGUAGE "Russian"
!insertmacro MUI_LANGUAGE "Slovak"
!insertmacro MUI_LANGUAGE "Spanish"
!insertmacro MUI_LANGUAGE "Swedish"
!insertmacro MUI_LANGUAGE "Turkish"
!insertmacro MUI_LANGUAGE "Ukrainian"

Var InputVer
Var VER
Var MAINVER
Function nsDialogsPage
	nsDialogs::Create 1018
	Pop $0
	${NSD_CreateLabel} 0 0 100% 12u "Enter Version Number:"
	Pop $0
	${NSD_CreateText} 0 13u 100% 12u ""
	Pop $InputVer
	nsDialogs::Show
FunctionEnd
Function nsDialogsPageLeave
	${NSD_GetText} $InputVer $R0
StrCmp $R0 "" 0 +3
	MessageBox MB_ICONEXCLAMATION `You must enter a version number!`
Abort
	StrCpy $VER "$R0"
	StrCpy $MAINVER "$R0" 1
FunctionEnd

Var LNG
Function MultiLang
Push ""
Push ${LANG_ENGLISH}
Push English
Push ${LANG_SIMPCHINESE}
Push SimpChinese
Push ${LANG_TRADCHINESE}
Push TradChinese
Push ${LANG_DANISH}
Push Danish
Push ${LANG_DUTCH}
Push Dutch
Push ${LANG_FRENCH}
Push French
Push ${LANG_GERMAN}
Push German
Push ${LANG_HUNGARIAN}
Push Hungarian
Push ${LANG_ITALIAN}
Push Italian
Push ${LANG_JAPANESE}
Push Japanese
Push ${LANG_LITHUANIAN}
Push Lithuanian
Push ${LANG_POLISH}
Push Polish
Push ${LANG_PORTUGUESE}
Push Portuguese
Push ${LANG_RUSSIAN}
Push Russian
Push ${LANG_SLOVAK}
Push Slovak
Push ${LANG_SPANISH}
Push Spanish
Push ${LANG_SWEDISH}
Push Swedish
Push ${LANG_TURKISH}
Push Turkish
Push ${LANG_UKRAINIAN}
Push Ukrainian

Push A ; A means auto count languages; for the auto count to work the first empty push (Push "") must remain
LangDLL::LangDialog "${APPNAME} Portable Language" "Please select application language."
Pop $LANGUAGE
StrCmp $LANGUAGE "cancel" 0 +2
Abort
StrCmp $LANGUAGE ${LANG_ENGLISH} 0 +2
StrCpy $LNG "English"
StrCmp $LANGUAGE ${LANG_SIMPCHINESE} 0 +2
StrCpy $LNG "Chinese_Simplified"
StrCmp $LANGUAGE ${LANG_TRADCHINESE} 0 +2
StrCpy $LNG "Chinese_Traditional"
StrCmp $LANGUAGE ${LANG_DANISH} 0 +2
StrCpy $LNG "Danish"
StrCmp $LANGUAGE ${LANG_DUTCH} 0 +2
StrCpy $LNG "Dutch"
StrCmp $LANGUAGE ${LANG_FRENCH} 0 +2
StrCpy $LNG "French"
StrCmp $LANGUAGE ${LANG_GERMAN} 0 +2
StrCpy $LNG "German"
StrCmp $LANGUAGE ${LANG_HUNGARIAN} 0 +2
StrCpy $LNG "Hungarian"
StrCmp $LANGUAGE ${LANG_ITALIAN} 0 +2
StrCpy $LNG "Italian"
StrCmp $LANGUAGE ${LANG_JAPANESE} 0 +2
StrCpy $LNG "Japanese"
StrCmp $LANGUAGE ${LANG_LITHUANIAN} 0 +2
StrCpy $LNG "Lithuanian"
StrCmp $LANGUAGE ${LANG_POLISH} 0 +2
StrCpy $LNG "Polish"
StrCmp $LANGUAGE ${LANG_PORTUGUESE} 0 +2
StrCpy $LNG "Portuguese_PT"
StrCmp $LANGUAGE ${LANG_RUSSIAN} 0 +2
StrCpy $LNG "Russian"
StrCmp $LANGUAGE ${LANG_SLOVAK} 0 +2
StrCpy $LNG "Slovak"
StrCmp $LANGUAGE ${LANG_SPANISH} 0 +2
StrCpy $LNG "Spanish"
StrCmp $LANGUAGE ${LANG_SWEDISH} 0 +2
StrCpy $LNG "Swedish"
StrCmp $LANGUAGE ${LANG_TURKISH} 0 +2
StrCpy $LNG "Turkish"
StrCmp $LANGUAGE ${LANG_UKRAINIAN} 0 +2
StrCpy $LNG "Ukrainian"
FunctionEnd

Section "${APPNAME} Portable" main
DetailPrint "Installing ${APPNAME} Portable"

Call CheckConnected
	inetc::get "${RELEASURL}-$VER.zip" "$TEMP\${APP}PortableTemp\${APP}-$VER.zip" /END
	Pop $0
StrCmp $0 "OK" +3
	MessageBox MB_USERICON "Download of ${APP}-$VER.zip: $0"
	Abort

	SetOutPath "$INSTDIR"
StrCmp $MAINVER "1" 0 +2
		File "..\..\..\${FOLDER}\${APP}1Portable.exe"
StrCmp $MAINVER "2" 0 +2
		File "..\..\..\${FOLDER}\${APP}2Portable.exe"

	File "/oname=$TEMP\${APP}PortableTemp\7za.exe" "..\_Include\7-Zip\7za.exe"
	nsExec::Exec `"$TEMP\${APP}PortableTemp\7za.exe" x "$TEMP\${APP}PortableTemp\${APP}-$VER.zip" -aoa -o"$INSTDIR\App\${APP}$MAINVER"`
DetailPrint "Installing ${APPNAME} Portable"
StrCmp $LNG "English" +4
	inetc::get "${RELEASURL}-$VER-$LNG.zip" "$TEMP\${APP}PortableTemp\${APP}-$VER-$LNG.zip" /END
	Pop $0
	nsExec::Exec `"$TEMP\${APP}PortableTemp\7za.exe" x "$TEMP\${APP}PortableTemp\${APP}-$VER-$LNG.zip" -aoa -o"$INSTDIR\App\${APP}$MAINVER\Languages"`

SectionEnd

Function .onGUIEnd
!ifdef DESCRIPTION
Call AppInfo
!endif
!ifdef SOURCES
Call Sources
	SetOutPath "$INSTDIR\Other\_Include\7-Zip"
	File "..\_Include\7-Zip\7za.exe"
	SetOutPath "$INSTDIR\Other\Source"
	File "_${APP}1Portable.nsi"
	File "KeePass.config.xml"
!endif
!ifdef SOURCES & DESCRIPTION
Call SourceInfo
!endif
!ifndef TEST
	RMDir "/r" "$TEMP\${APP}PortableTemp"
!endif
FunctionEnd

